invites:batch-invite-bidders
Adds bidders to multiple bid packages using their userId or email. The invites will be sent to the bidders when their respective bid packages are published. If any bid packages have already been published, then the invites for those bid packages will be sent immediately.
A bidder may be added to an existing invite of the bid package or a new invite may be created for the bidder in that bid package.
The API user must be a member of the project team to add bidders to a bid package.
If the bidders to invite will make the bid package’s total bidders exceed 500, the API request will fail completely with TOO_MANY_BIDDERS error message.
If parameters passed in request body are invalid or not in correct format, the API request will fail completely.
Resource Information
| Method and URI | POST https://developer.api.autodesk.com/construction/buildingconnected/v2/invites:batch-invite-bidders |
| Authentication Context | User context required |
| Required OAuth Scopes | data:write |
| Data Format | JSON |
Request
Headers
| Authorization* string | Must be Bearer <token>, where <token> is a three-legged access token obtained via an Authorization Code flow. |
| Content-Type* string | Must be application/json |
Request
Body Structure
Invites to create for a bid package. Max 100 bid packages per call.
| bidPackageId* string | The unique ID of the bid package. To find the ID, call GET bid-packages.
Max length: 24 |
| invitees* array: object | The array of bidders to add to a bid package. Requires either email or userId. selectedOfficeId can be passed along with the userId.
A maximum of 100 invitees can be added per call. |
| email string | Email of the bidder. |
| userId string | UserId of the bidder. |
| selectedOfficeId string | Provides context on which office this bidder is being invited from (if they belong to many). This controls which officeId appears on the invite for this bidder if a new one is created. Ignored if bidder is added to an existing invite. Defaults to user’s primary office. |
| placeholderCompanyName string | Temporary company name used for unknown company.
Max length: 22000 |
Response
HTTP Status Code Summary
| 201 Created | Created |
| 207 | Multi Status |
| 400 Bad Request | The parameters of the requested operation are invalid. |
| 401 Unauthorized | The provided bearer token is not valid. |
| 403 Forbidden | The user or service represented by the bearer token does not have permission to perform this operation. |
| 404 Not Found | The requested resource could not be found. |
| 429 Too Many Requests | Rate limit exceeded; wait some time before retrying. The ‘Retry-After’ header might provide the amount of the time to wait. |
| 500 Internal Server Error | An unknown error occurred on the server. |
Response
Header (201)
| Location string | The created resource’s location. |
Response
Body Structure (201)
| results array: object | The list of invitees. |
| id string | The unique invite ID. If this company is invited to a different bid package, an additional entry will be generated.
Max length: 24 |
| projectId string | The unique ID of the project with which the invite is associated.
Max length: 24 |
| projectName string | The name of the project with which the invite is associated. |
| bidPackageId string | The unique ID of the bid package that the invite is for.
Max length: 24 |
| bidPackageName string | The name of the bid package that the invite is for. |
| currentAccLinkedProjectId string | The project ID of the Forma project currently linked to from this invites’s BuildingConnected project. |
| bidderOfficeId string | The unique BuildingConnected office ID of the office that owns the invite.
Max length: 24 |
| bidderCompany object | Information about a company. |
| id string | The unique BuildingConnected ID of the company.
Max length: 24 |
| name string | The name of the company. |
| avatarImageUrl string | The cached imgix url for the avatar image of the company. |
| businessType array: string | The type of business carried out by the company. |
| website string | The company’s official website. |
| laborType array: string | Specifies the labor payment structure within the company, such as Non-Union or Prevailing Wages. |
| enterpriseType array: string | This has been deprecated and replaced with certificates. |
| companyTags array: string | A list of tags assigned by your organization to categorize this company. Note that this information is private to your organization and not visible to others. |
| certificates array: object | A collection of certificates held by the company. This field replaces the deprecated enterpriseType field. |
| id string | The unique identifier for each certificate. Companies can hold multiple certificates, each with its own ID. The field is null for pending certificate suggestions.
Max length: 24 |
| type object | Details about the specific type of certificate. |
| id string | The unique ID of the certificate type.
Max length: 24 |
| name string | The name of the certificate type. |
| agency object | Details about the agency that issued the certificate. |
| id string | The unique identifier for the certifying agency.
Max length: 24 |
| name string | The name of the certifying agency. |
| website string | The official website URL of the certifying agency. |
| number string | The certificate’s unique identification number. |
| expiresAt datetime: ISO 8601 | The date the certificate expires, in ISO 8601 format. |
| fileName string | The name of the digital copy of the certificate. |
| placeholderCompanyName string | Temporary company name used for unknown company.
This field is always Max length: 22000 |
| state enum:string | The current state of the invite. The default state is NOT_INVITED. Possible values:
|
| createdAt datetime: ISO 8601 | The date and time the bidder was included in the bid package, in ISO 8601 format. |
| updatedAt datetime: ISO 8601 | The date and time of the latest update to the invite, in ISO 8601 format. |
| invitedAt datetime: ISO 8601 | The date and time the invite was sent and the corresponding opportunity was created, in ISO 8601 format. |
| invitees array: object | A list of users who have been invited. Note that invitees may not all belong to the same company.
Max 500 invitees per invite. |
| id string | The invitee’s ID.
Max length: 24 |
| userId string | The unique BuildingConnected user ID of the invitee.
Max length: 24 |
| firstName string | The invitee’s first name. |
| lastName string | The invitee’s last name. |
| companyId string | The ID of the invitee’s company.
Max length: 24 |
| phoneNumber string | The invitee’s phone number. |
| title string | The invitee’s professional title. |
| email string | The invitee’s email address. |
| isEmailValid boolean | Indicates whether this invitee’s email address is considered valid.
|
| inviterType enum:string | The type of inviter sending the bid invitation. Possible values: HOST, BIDDER, PUBLIC. |
| state enum:string | The current state of the invitee. Possible values: NOT_INVITED (default), INVITED, VIEWED, REMOVED. |
| firstViewedAt datetime: ISO 8601 | The first time that the invitee viewed the invite. Default value is NULL. |
| lastViewedAt datetime: ISO 8601 | The last time that the invitee viewed the invite. Default value is NULL. |
| ndaSignedAt datetime: ISO 8601 | The time when the invitee signed the NDA, if the invitee has signed it. Default value is NULL. |
Response
Body Structure (207)
| results array: object | The list of email invitees. |
| id string | The unique invite ID. If this company is invited to a different bid package, an additional entry will be generated.
Max length: 24 |
| projectId string | The unique ID of the project with which the invite is associated.
Max length: 24 |
| projectName string | The name of the project with which the invite is associated. |
| bidPackageId string | The unique ID of the bid package that the invite is for.
Max length: 24 |
| bidPackageName string | The name of the bid package that the invite is for. |
| currentAccLinkedProjectId string | The project ID of the Forma project currently linked to from this invites’s BuildingConnected project. |
| bidderOfficeId string | The unique BuildingConnected office ID of the office that owns the invite.
Max length: 24 |
| bidderCompany object | Information about a company. |
| id string | The unique BuildingConnected ID of the company.
Max length: 24 |
| name string | The name of the company. |
| avatarImageUrl string | The cached imgix url for the avatar image of the company. |
| businessType array: string | The type of business carried out by the company. |
| website string | The company’s official website. |
| laborType array: string | Specifies the labor payment structure within the company, such as Non-Union or Prevailing Wages. |
| enterpriseType array: string | This has been deprecated and replaced with certificates. |
| companyTags array: string | A list of tags assigned by your organization to categorize this company. Note that this information is private to your organization and not visible to others. |
| certificates array: object | A collection of certificates held by the company. This field replaces the deprecated enterpriseType field. |
| id string | The unique identifier for each certificate. Companies can hold multiple certificates, each with its own ID. The field is null for pending certificate suggestions.
Max length: 24 |
| type object | Details about the specific type of certificate. |
| id string | The unique ID of the certificate type.
Max length: 24 |
| name string | The name of the certificate type. |
| agency object | Details about the agency that issued the certificate. |
| id string | The unique identifier for the certifying agency.
Max length: 24 |
| name string | The name of the certifying agency. |
| website string | The official website URL of the certifying agency. |
| number string | The certificate’s unique identification number. |
| expiresAt datetime: ISO 8601 | The date the certificate expires, in ISO 8601 format. |
| fileName string | The name of the digital copy of the certificate. |
| placeholderCompanyName string | Temporary company name used for unknown company.
This field is always Max length: 22000 |
| state enum:string | The current state of the invite. The default state is NOT_INVITED. Possible values:
|
| createdAt datetime: ISO 8601 | The date and time the bidder was included in the bid package, in ISO 8601 format. |
| updatedAt datetime: ISO 8601 | The date and time of the latest update to the invite, in ISO 8601 format. |
| invitedAt datetime: ISO 8601 | The date and time the invite was sent and the corresponding opportunity was created, in ISO 8601 format. |
| invitees array: object | A list of users who have been invited. Note that invitees may not all belong to the same company.
Max 500 invitees per invite. |
| id string | The invitee’s ID.
Max length: 24 |
| userId string | The unique BuildingConnected user ID of the invitee.
Max length: 24 |
| firstName string | The invitee’s first name. |
| lastName string | The invitee’s last name. |
| companyId string | The ID of the invitee’s company.
Max length: 24 |
| phoneNumber string | The invitee’s phone number. |
| title string | The invitee’s professional title. |
| email string | The invitee’s email address. |
| isEmailValid boolean | Indicates whether this invitee’s email address is considered valid.
|
| inviterType enum:string | The type of inviter sending the bid invitation. Possible values: HOST, BIDDER, PUBLIC. |
| state enum:string | The current state of the invitee. Possible values: NOT_INVITED (default), INVITED, VIEWED, REMOVED. |
| firstViewedAt datetime: ISO 8601 | The first time that the invitee viewed the invite. Default value is NULL. |
| lastViewedAt datetime: ISO 8601 | The last time that the invitee viewed the invite. Default value is NULL. |
| ndaSignedAt datetime: ISO 8601 | The time when the invitee signed the NDA, if the invitee has signed it. Default value is NULL. |
| errors array: object | List of invites that failed to be created. |
| title string | A short name for the error |
| error string | A short explanation to help with error diagnosis. |
| invites array: object | The invites associated with this error. |
| id string | The unique invite ID. If this company is invited to a different bid package, an additional entry will be generated.
Max length: 24 |
| projectId string | The unique ID of the project with which the invite is associated.
Max length: 24 |
| projectName string | The name of the project with which the invite is associated. |
| bidPackageId string | The unique ID of the bid package that the invite is for.
Max length: 24 |
| bidPackageName string | The name of the bid package that the invite is for. |
| currentAccLinkedProjectId string | The project ID of the Forma project currently linked to from this invites’s BuildingConnected project. |
| bidderOfficeId string | The unique BuildingConnected office ID of the office that owns the invite.
Max length: 24 |
| bidderCompany object | Information about a company. |
| id string | The unique BuildingConnected ID of the company.
Max length: 24 |
| name string | The name of the company. |
| avatarImageUrl string | The cached imgix url for the avatar image of the company. |
| businessType array: string | The type of business carried out by the company. |
| website string | The company’s official website. |
| laborType array: string | Specifies the labor payment structure within the company, such as Non-Union or Prevailing Wages. |
| enterpriseType array: string | This has been deprecated and replaced with certificates. |
| companyTags array: string | A list of tags assigned by your organization to categorize this company. Note that this information is private to your organization and not visible to others. |
| certificates array: object | A collection of certificates held by the company. This field replaces the deprecated enterpriseType field. |
| id string | The unique identifier for each certificate. Companies can hold multiple certificates, each with its own ID. The field is null for pending certificate suggestions.
Max length: 24 |
| type object | Details about the specific type of certificate. |
| id string | The unique ID of the certificate type.
Max length: 24 |
| name string | The name of the certificate type. |
| agency object | Details about the agency that issued the certificate. |
| id string | The unique identifier for the certifying agency.
Max length: 24 |
| name string | The name of the certifying agency. |
| website string | The official website URL of the certifying agency. |
| number string | The certificate’s unique identification number. |
| expiresAt datetime: ISO 8601 | The date the certificate expires, in ISO 8601 format. |
| fileName string | The name of the digital copy of the certificate. |
| placeholderCompanyName string | Temporary company name used for unknown company.
This field is always Max length: 22000 |
| state enum:string | The current state of the invite. The default state is NOT_INVITED. Possible values:
|
| createdAt datetime: ISO 8601 | The date and time the bidder was included in the bid package, in ISO 8601 format. |
| updatedAt datetime: ISO 8601 | The date and time of the latest update to the invite, in ISO 8601 format. |
| invitedAt datetime: ISO 8601 | The date and time the invite was sent and the corresponding opportunity was created, in ISO 8601 format. |
| invitees array: object | A list of users who have been invited. Note that invitees may not all belong to the same company.
Max 500 invitees per invite. |
| id string | The invitee’s ID.
Max length: 24 |
| userId string | The unique BuildingConnected user ID of the invitee.
Max length: 24 |
| firstName string | The invitee’s first name. |
| lastName string | The invitee’s last name. |
| companyId string | The ID of the invitee’s company.
Max length: 24 |
| phoneNumber string | The invitee’s phone number. |
| title string | The invitee’s professional title. |
| email string | The invitee’s email address. |
| isEmailValid boolean | Indicates whether this invitee’s email address is considered valid.
|
| inviterType enum:string | The type of inviter sending the bid invitation. Possible values: HOST, BIDDER, PUBLIC. |
| state enum:string | The current state of the invitee. Possible values: NOT_INVITED (default), INVITED, VIEWED, REMOVED. |
| firstViewedAt datetime: ISO 8601 | The first time that the invitee viewed the invite. Default value is NULL. |
| lastViewedAt datetime: ISO 8601 | The last time that the invitee viewed the invite. Default value is NULL. |
| ndaSignedAt datetime: ISO 8601 | The time when the invitee signed the NDA, if the invitee has signed it. Default value is NULL. |
Example
Multi Status
Request
curl -v 'https://developer.api.autodesk.com/construction/buildingconnected/v2/invites:batch-invite-bidders' \
-X 'POST' \
-H 'Authorization: Bearer AuIPTf4KYLTYGVnOHQ0cuolwCW2a' \
-H 'Content-Type: application/json' \
-d '[
{
"bidPackageId": "590dd127b359f408f190b5a7",
"invitees": [
{
"userId": "5654f7bf8845796ad73bd4e0",
"selectedOfficeId": "57d2bd7450b37a0c52585d2a",
"placeholderCompanyName": null
},
{
"userId": "5654f7bf8845796ad73bd4e2",
"placeholderCompanyName": "Sample Company"
}
]
},
{
"bidPackageId": "590dd127b359f408f190b5a8",
"invitees": [
{
"email": "someone@gmail.com",
"placeholderCompanyName": null
},
{
"userId": "5654f7bf8845796ad73bd4e1",
"placeholderCompanyName": null
}
]
}
]'
Response
{
"results": [
{
"id": "590dd527b359f408f191b5b6",
"projectId": "59d2bd7440b36a0da258f24d",
"projectName": "Chase Center Arena",
"bidPackageId": "590dd127b359f408f190b5a7",
"bidPackageName": "Electrical",
"currentAccLinkedProjectId": "00f1b796-293a-4c1e-9474-f09711011426",
"bidderOfficeId": "57d2bd7450b37a0c52585d2a",
"bidderCompany": {
"id": "51bea397f5846f95994b1da7",
"name": "Gr8 Builders",
"avatarImageUrl": "https://www.example.com/",
"businessType": [
"Subcontractor"
],
"website": "https://www.example.com",
"laborType": [
"Union"
],
"enterpriseType": [
"Disadvantaged Business Enterprise (DBE)"
],
"companyTags": [
"example_tag"
],
"certificates": [
{
"id": "627074db25c97830ad3ea8c8",
"type": {
"id": "59d2bd7440b36a0da258f24d",
"name": "Disadvantaged Business Enterprise (DBE)"
},
"agency": {
"id": "611d794f7f063800a7274d46",
"name": "United States Department of Transportation",
"website": "https://www.transportation.gov/civil-rights/disadvantaged-business-enterprise"
},
"number": "12345",
"expiresAt": "2014-10-03T19:00:00.000Z",
"fileName": "certificate.pdf"
}
]
},
"placeholderCompanyName": null,
"state": "UNDECIDED",
"createdAt": "2014-09-25T20:00:00.000Z",
"updatedAt": "2014-09-25T21:00:00.000Z",
"invitedAt": "2014-09-25T20:30:00.000Z",
"invitees": [
{
"id": "5cfe43c079b25e7dcafc104d",
"userId": "5bff41c079b25e7ccebc202e",
"firstName": "First",
"lastName": "Last",
"companyId": "51bea397f5846f95994b1da7",
"phoneNumber": "555-555-5555",
"title": "Estimator",
"email": "someone@gmail.com",
"isEmailValid": true,
"inviterType": "HOST",
"state": "INVITED",
"firstViewedAt": "2021-01-08T13:00:00.000Z",
"lastViewedAt": "2021-01-10T09:00:00.000Z",
"ndaSignedAt": null
}
]
}
],
"errors": [
{
"title": "Not Found",
"error": "Invite could not be created",
"invites": [
{
"id": "590dd527b359f408f191b5b6",
"projectId": "59d2bd7440b36a0da258f24d",
"projectName": "Chase Center Arena",
"bidPackageId": "590dd127b359f408f190b5a7",
"bidPackageName": "Electrical",
"currentAccLinkedProjectId": "00f1b796-293a-4c1e-9474-f09711011426",
"bidderOfficeId": "57d2bd7450b37a0c52585d2a",
"bidderCompany": {
"id": "51bea397f5846f95994b1da7",
"name": "Gr8 Builders",
"avatarImageUrl": "https://www.example.com/",
"businessType": [
"Subcontractor"
],
"website": "https://www.example.com",
"laborType": [
"Union"
],
"enterpriseType": [
"Disadvantaged Business Enterprise (DBE)"
],
"companyTags": [
"example_tag"
],
"certificates": [
{
"id": "627074db25c97830ad3ea8c8",
"type": {
"id": "59d2bd7440b36a0da258f24d",
"name": "Disadvantaged Business Enterprise (DBE)"
},
"agency": {
"id": "611d794f7f063800a7274d46",
"name": "United States Department of Transportation",
"website": "https://www.transportation.gov/civil-rights/disadvantaged-business-enterprise"
},
"number": "12345",
"expiresAt": "2014-10-03T19:00:00.000Z",
"fileName": "certificate.pdf"
}
]
},
"placeholderCompanyName": null,
"state": "UNDECIDED",
"createdAt": "2014-09-25T20:00:00.000Z",
"updatedAt": "2014-09-25T21:00:00.000Z",
"invitedAt": "2014-09-25T20:30:00.000Z",
"invitees": [
{
"id": "5cfe43c079b25e7dcafc104d",
"userId": "5bff41c079b25e7ccebc202e",
"firstName": "First",
"lastName": "Last",
"companyId": "51bea397f5846f95994b1da7",
"phoneNumber": "555-555-5555",
"title": "Estimator",
"email": "someone@gmail.com",
"isEmailValid": true,
"inviterType": "HOST",
"state": "INVITED",
"firstViewedAt": "2021-01-08T13:00:00.000Z",
"lastViewedAt": "2021-01-10T09:00:00.000Z",
"ndaSignedAt": null
}
]
}
]
}
]
}